
#ifndef __ANIME_H__
#define __ANIME_H__
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
#define FACE_SPR_NO						0
#define FACE_SPR_X						164
#define FACE_SPR_Y						30
#define FACE_SPR_TILE_NO_NORMAL			512
#define FACE_SPR_TILE_NO_SLEEP			520
#define FACE_SPR_TILE_NO_AWAKE			528
#define FACE_SPR_TILE_NO_SCARE			536

//---------------------------------------------------------------------------

enum {
	ANIME_NO_NORMAL = 0x01,
	ANIME_NO_DROP,
	ANIME_NO_SHAKE,
	ANIME_NO_SLEEP1,
	ANIME_NO_SLEEP2,
	ANIME_NO_AWAKE,

	ANIME_NO_FACE_NORMAL,
	ANIME_NO_FACE_AWAKE,
	ANIME_NO_FACE_SCARE,
};


enum {
	ANIME_PAT_NO_IMG = 0x01,
	ANIME_PAT_NO_CHG_X,
	ANIME_PAT_NO_CHG_Y,
	ANIME_PAT_NO_CHG_F,			//FACE
	ANIME_PAT_NO_WAIT,
	ANIME_PAT_NO_END,
};


enum {
	FACE_NO_NORMAL = 0x01,
	FACE_NO_SLEEP,
	FACE_NO_DRIVE,
	FACE_NO_SCARE,
};

//---------------------------------------------------------------------------
typedef struct {
	u16  no;
} ST_ANIME;


typedef struct {
	u8   no;
	char name[13];
	u16  var;
} ST_ANIME_PAT;


typedef struct {
	u16 x;
	u16 y;
	u16 tile;
} ST_FACE;

//---------------------------------------------------------------------------
EWRAM_CODE void AnimeInit();

EWRAM_CODE void AnimeSetNo(u16 no);

EWRAM_CODE void AnimeExec();
EWRAM_CODE void AnimeExecPat(ST_ANIME_PAT* p);
EWRAM_CODE void AnimeExecPatImg(char* pName, u16 wait);
EWRAM_CODE void AnimeExecPatWait(u16 wait);


EWRAM_CODE void FaceInit();
EWRAM_CODE void FaceInitSpr();

EWRAM_CODE void FaceSetNo(u16 tileNo);
EWRAM_CODE void FaceSetX(u16 x);
EWRAM_CODE void FaceSetY(u16 y);





#ifdef __cplusplus
}
#endif
#endif
