
#include "inc.h"

#include "minix.h"
#include "irq_arm.h"
#include "bios_arm.h"
#include "div_arm.h"
#include "ad_arm.h"
#include "gbfs.h"
#include "lib.h"

#include "rand.h"
#include "main.h"

#include "music.h"

//---------------------------------------------------------------------------
ST_MUSIC Music;

//---------------------------------------------------------------------------
EWRAM_CODE void MusicInit()
{
	u8* pData = GBFSGetFilePointer("miku.8ad");
	u32 size  = GBFSGetFileSize();

	if(pData == NULL)
	{
		SystemError("[Err] Music File Not Found.", NULL);
	}

	_Memset((u8*)&Music, 0x00, sizeof(ST_MUSIC));

	Music.pData = pData;
	Music.size  = size;

	AdInit();
}
//---------------------------------------------------------------------------
EWRAM_CODE void MusicStart()
{
	ST_MUSIC* p = &Music;

	AdStart(p->pData, p->size, FALSE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void MusicStop()
{
	AdStop();
}
